#include "PluginHostAdapter.h"
#include "Plugin.h"
#include "PluginBase.h"
#include "vamp.h"

class Aubio
{
  public:
	 Aubio();
	~Aubio();
	void                      run();
	void                      set_threshold(double);
	std::map<std::string, int>* get_onset_types();

	Vamp::Plugin::FeatureSet* results;
	std::list<Vamp::RealTime> out;
	double                    threshold;
  protected:
	void                      process_output(int frame, Vamp::Plugin::FeatureSet features);

	int                       step_size;
	int                       block_size;
	bool                      mix;
	Vamp::PluginHostAdapter*  plugin;
	void*                     libraryHandle;
	float*                    filebuf;
	float**                   plugbuf;

	std::map<std::string, int>* onset_types;
};
