#ifndef __ayyi_types_h__
#define __ayyi_types_h__

//media types
typedef enum {
	AYYI_AUDIO = 1,
	AYYI_MIDI
} MediaType;

//methods
typedef enum {
	AYYI_NEW = 1,
	AYYI_DEL,
	AYYI_GET,
	AYYI_SET,
	AYYI_UNDO
} AyyiOp;

//object types
typedef enum {
	AYYI_OBJECT_EMPTY = 0,
	AYYI_OBJECT_TRACK,
	AYYI_OBJECT_AUDIO_TRACK,
	AYYI_OBJECT_MIDI_TRACK,
	AYYI_OBJECT_CHAN,
	AYYI_OBJECT_AUX,
	AYYI_OBJECT_PART,
	AYYI_OBJECT_AUDIO_PART,
	AYYI_OBJECT_MIDI_PART,
	AYYI_OBJECT_EVENT,
	AYYI_OBJECT_RAW,
	AYYI_OBJECT_STRING,
	AYYI_OBJECT_ROUTE,
	AYYI_OBJECT_FILE,
	AYYI_OBJECT_LIST,
	AYYI_OBJECT_MIDI_NOTE,
	AYYI_OBJECT_SONG,
	AYYI_OBJECT_TRANSPORT,
	AYYI_OBJECT_LOCATORS,
	AYYI_OBJECT_AUTO,
	AYYI_OBJECT_METRONOME,
	AYYI_OBJECT_UNSUPPORTED,
	AYYI_OBJECT_ALL
#ifdef __cplusplus
} ObjType;
#else
} AyyiObjType;
#endif

//properties
enum {
	AYYI_NO_PROP,
	AYYI_NAME,
	AYYI_STIME,
	AYYI_LENGTH,
	AYYI_HEIGHT,
	AYYI_COLOUR,
	AYYI_END,
	AYYI_TRACK,
	AYYI_MUTE,
	AYYI_ARM,
	AYYI_SOLO,
	AYYI_SDEF,
	AYYI_INSET,
	AYYI_FADEIN,
	AYYI_FADEOUT,
	AYYI_INPUT,
	AYYI_OUTPUT,
	AYYI_AUX1_OUTPUT,
	AYYI_AUX2_OUTPUT,
	AYYI_AUX3_OUTPUT,
	AYYI_AUX4_OUTPUT,
	AYYI_PREPOST,
	AYYI_SPLIT,

	AYYI_PB_LEVEL,
	AYYI_PB_PAN,
	AYYI_PB_DELAY_MU,
	AYYI_PLUGIN_SEL,
	AYYI_PLUGIN_BYPASS,

	AYYI_CHAN_LEVEL,
	AYYI_CHAN_PAN,

	AYYI_TRANSPORT_PLAY,
	AYYI_TRANSPORT_STOP,
	AYYI_TRANSPORT_REW,
	AYYI_TRANSPORT_FF,
	AYYI_TRANSPORT_REC,
	AYYI_TRANSPORT_LOCATE,
	AYYI_TRANSPORT_CYCLE,
	AYYI_TRANSPORT_LOCATOR,

	AYYI_AUTO_PT,

	AYYI_ADD_POINT,
	AYYI_DEL_POINT,

	AYYI_TEMPO,
	AYYI_HISTORY,

	AYYI_LOAD_SONG,
	AYYI_SAVE,
	AYYI_NEW_SONG
};


#define AYYI_SUBS_PER_BEAT 3840
#define AYYI_MU_PER_SUB 11025

struct _song_pos
{
	int beat;
	unsigned short sub;
	unsigned short mu;
};


struct _ayyi_obj_idx
{
	uint32_t idx1;
	uint32_t idx2;
	uint32_t idx3;
};


enum {
	VOL = 0,
	PAN,
	AUTO_MAX
};

enum // channel/track/aux flags
{
	muted  = 1 << 0,
	solod  = 1 << 1,
	armed  = 1 << 2,
	master = 1 << 3,
	deleted= 1 << 4,
}/* ChanFlags*/;

#endif // __ayyi_types_h__
