
//this class is for creating new song objects and matches with the *_object_new() calls.
class song_object
{
  public:
	song_object(std::string name);

	int               obj_type;
	std::string       name;
	bool              from_source;
	uint32_t          src_idx;
	guint32           parent_idx;
	struct _song_pos  stime;
	guint64           len;
	uint32_t          inset;
};


class Action
{
  public:
	               Action(std::string description);
	              ~Action();
	void           execute();
	void           complete();

	unsigned       id;
	struct timeval time_stamp;

	//the following are filled in by the originator of the transaction:

	void           (*callback)(Action*); // the func to call upon reception of succesful completion of the transaction
	char           label[64];     // a description of the transaction. For printing only.
	int            value;
	int            val2;
	int            gdata;         // used to access gui data not referenced in the songcore.
	void*          gdata2;

	//the following are filled in by the recipient of the transaction:

	int            gid;           // the id number returned from core following the transaction.
	int            idx;           // the song sobject index number returned from the server.
	char           err;           // zero if no errors reported.

	std::list<Action*> pending;   // list of actions that must be completed before this one is started.

	//values used to construct the message:
	int            op;
	int            obj_type;
	uint32_t       obj_idx;
	int            prop;
	int            i_val;
	song_object*   obj;
};


class Messenger
{
  public:
	Messenger();
	virtual int    get_shm(const char* seg_name);
	bool           service_test();
	bool           send(Action*);
};


