#include <sys/time.h>
#include <iostream>
#include <list>
#include <gtkmm.h>
using std::cout;
using std::cerr;
using std::endl;
using std::string;
#include "ayyi.h"

#include "dbus/dbus_marshallers.h"

#define dbg(LEVEL, A, ...) dbgprintf2("dbus", __func__, LEVEL, (char*)A, ##__VA_ARGS__)
#define warn(A, ...) warnprintf("dbus", __func__, (char*)A, ##__VA_ARGS__)
#define err(A, ...) errprintf("dbus", __func__, (char*)A, ##__VA_ARGS__)
#define PF printf("dbus::%s()...\n", __func__);
#define P_IN printf("%s--->%s ", green, white)
#define SIG_IN printf("%s--->%s %s\n", bold, white, __func__)
#define SIG_IN1 printf("%s--->%s ", bold, white)
#define SIG_OUT printf("%s(): %s--->%s\n", __func__, yellow, white)

extern DBusGProxy *proxy;
extern DBusGProxy *session_proxy;

int
Dbus::get_shm(const char* seg_name)
{
	int shm_id = 0;
#define DBUS_SYNC
#ifdef DBUS_SYNC
	GError* error = NULL;
	dbg(0, "seg_name=%s", seg_name);
	if(!dbus_g_proxy_call(proxy, "GetShmSingle", &error, G_TYPE_STRING, seg_name, G_TYPE_INVALID, G_TYPE_UINT, &shm_id, G_TYPE_INVALID)){

			//just to demonstrate remote exceptions versus regular GError
			if(error->domain == DBUS_GERROR && error->code == DBUS_GERROR_REMOTE_EXCEPTION){
				err("caught remote method exception %s: %s", dbus_g_error_get_name(error), error->message);
			}else{
				err("GetShm: %s\n", error->message);
			}
			g_error_free(error);

			return false;
	}
	//dbg("fd=%i", (*seg).id);

	//dbus_shm_notify(proxy, NULL, (void*)&(*seg));
#else
	dbus_g_proxy_begin_call(proxy, "GetShmSingle", dbus_shm_notify, NULL, NULL, G_TYPE_STRING, segs[i], G_TYPE_INVALID);
#endif
	return shm_id;
}


