#define CLIENT_SHM_CC
#include <sys/shm.h>
#include <jack/jack.h>
#include <gtkmm.h>

#include "ayyi.h"

#define dbg(A, ...) dbgprintf("client_shm", __func__, (char*)A, ##__VA_ARGS__)
#define warn(A, ...) warnprintf("client_shm", __func__, (char*)A, ##__VA_ARGS__)
#define err(A, ...) errprintf("client_shm", __func__, (char*)A, ##__VA_ARGS__)
#define PF printf("client_shm::%s()...\n", __func__);

int shm_page_size = 0;
extern Ayyi_client* ayyi;

template<class P>
client_shm<P>::client_shm()
	: attached(false),
	  type(1)           //temporary
{
	shm_page_size = sysconf(_SC_PAGESIZE);
}
template client_shm<struct _shm_song>::client_shm();


template<class P>
bool
client_shm<P>::import()
{
	dbg(0, "...");

	if(this->id){
		if(this->attached){ dbg("seg already attached."); return false; }

		void* shmptr;
		if((shmptr = shmat(id, 0, 0)) == (void *)-1){
			err("shmat() %s\n", fail);
			return false;
		}
		attached = true;

		//switch(type){
		//	case 1:
				data = (P*)shmptr;
				//if(shm.song->version != 1) warnprintf("wrong shm version: %i - should be %i", shm.song->version, 1);
		//		break;
		//	default:
		//		err("unexpected shm segment type %i\n", type);
		//		break;
		//}
	} else { err("segment has no id!\n"); return false; }

	if(data->version != AYYI_SHM_VERSION){ err("wrong shm version: %i (expected %i)", data->version, AYYI_SHM_VERSION); return false; }

	size = data->num_pages * shm_page_size;
	if(!size){ err("segment has zero size.\n"); return false; }

	//dbg("id=%i this=%p=%p data=%p=%p", id, this, &ayyi->song_shm, data, ayyi->song_shm.data);
	printf("client_shm::%s(): %s sig='%s' rate=%i \n%s%s\n", __func__, seg_strs[type], data->service_name, data->sample_rate, go_rhs, ok);
	return true;
}
template bool client_shm<struct _shm_song>::import();

