#include "stdint.h"

#define ASSERT_POINTER(A, B) if((unsigned)A < 1024){ err("bad %s pointer (%p).\n", B, A); return; } 

void dbgprintf(const char* claas, const char* func, char *format, ...);
void dbgprintf2(const char* claas, const char* func, int level, char *format, ...);
void errprintf(const char* claas, const char* func, char *format, ...);
void warnprintf(const char* claas, const char* func, char *format, ...);

void filename_change_extension(char* path, const char* extn);

void color_rgba_to_gdk(GdkColor*, uint32_t rgba);
void pixbuf_fill_rgb(GdkPixbuf*, GdkColor*);
void pixbuf_draw_line(GdkPixbuf*, struct _ArtDRect* pts, double line_width, GdkColor*);

GList* get_dirlist(const char* path);
bool audio_path_get_leaf(const char* path, char* leaf);

uint64_t beats2mu(double beats);
void mu2pos(uint64_t mu, struct _song_pos *pos);

#ifdef UTILS_CC
char white [16] = "\x1b[0;39m";
char bold  [16] = "\x1b[1;39m";
char yellow[16] = "\x1b[1;33m";
char red   [16] = "\x1b[1;31m";
char green [16] = "\x1b[1;32m";
char go_rhs[32] = "\x1b[A\x1b[60C"; //go up one line, then goto column 60
char ok    [32] = " [ \x1b[1;32mok\x1b[0;39m ]";
char fail  [32] = " [ \x1b[1;31mFAIL\x1b[0;39m ]";
#else
extern char white [16];
extern char bold  [16];
extern char yellow[16];
extern char red   [16];
extern char green [16];
extern char go_rhs[32];
extern char ok    [];
extern char fail  [];
#endif
