#include "stdint.h"
#include "wave.h"

#ifndef __ART_RECT_H__
struct _ArtDRect {
  double x0, y0, x1, y1;
};
#endif

const int   PEAKS_PER_BLOCK = 256; //defines the texture size

typedef struct _gl_blocks
{
  int                size;
  unsigned*          texture_name;
  double             last_used;     // the fraction of the last block that is actually used.

} gl_blocks;


class Peak
{
  public:
	            Peak(Wave*);
	           ~Peak();
	gboolean    load(gpointer _block_num);
	bool        get_filename(const char* fullpath, int ch_num);
	void        draw();
	GdkPixbuf*  block_to_pixbuf(int blocknum);
	void        render_to_pixbuf(GdkPixbuf*, uint32_t region_idx, int* start, int* end, GdkColor* colour, uint32_t colour_bg);
	double      block_get_width_px(int blocknum);

	Wave*       wave;
	short*      buf0;//[2]; // copy of the peakfile. Pairs of min and max values.
	int         buflen;     // words
	int         num_peaks;
	int         byte_depth; // 4 in this case.
	bool        use_float;  // TRUE
	bool        valid;
	gl_blocks*  blocks;     // opengl textures.

	float       max_db;
  protected:
	void        set_buflen();
	bool        load_peakfile();

	string      filename;
};


