#include <iostream>
#include <gtkmm.h>
using std::cout;
using std::cerr;
using std::endl;
using std::string;
#include <GL/gl.h>
#include <GL/glu.h>

class Peak;
#include "PluginHostAdapter.h"
#include "Plugin.h"
#include "PluginBase.h"
#include "vamp.h"
#include "ayyi.h"
#include "window.h"

#define MAG 1.0f            //temp!! to be removed!!
#define PX_TO_GL 1 * MAG //scales a gnomecanvas px value to gl coords

#define dbg(LEVEL, A, ...) dbgprintf2("rulerbar", __func__, LEVEL, A, ##__VA_ARGS__)
#define PF printf("rulerbar::%s()...\n", __func__);

extern AppWindow*   window;


void
Rulerbar::draw()
{
	GLScene* scene = &window->glScene;

	const double top = scene->get_height();
	static const double y[4] = {4.0 * MAG, 2.0 * MAG, 1.0 * MAG, 0.5 * MAG};

	const int beats2bar = 4;
	double hzoom = 1.0;

	gpos pos = {1, 0, 0};
	double beat_width = scene->pos2px(&pos) * PX_TO_GL;

	glColor3f(1.0, 1.0, 1.0);
	//glDisable(GL_BLEND);

	//FIXME dont start at zero!
	double px_left = 0;
	//gpos left_pos = arr_px2pos(left);
	double beat = scene->px2beat(px_left);
	int first_segment = 0;//beat / (4 * song->beats2bar);

	int i, j, k, m;
	for(i=first_segment; i<first_segment+20; i++){
		//start a 4 bar segment
		pos.beat = i * 4 * beats2bar;
		double x = window->glScene.pos2px(&pos) * PX_TO_GL;
		dbg(2, "x=%.2f y=%.2f", x, y[2]);

		//if(x > arrange->canvas_scrollwin->allocation.width) break; //FIXME check is visible

		glLineWidth( 2 );
		glBegin( GL_LINES );
		glVertex3f( x, top-y[0], 0 );
		glVertex3f( x, top, 0 );
		glEnd();
		glPushMatrix();
		glColor3f(0.1, 0.1, 0.9);
		scene->print(x/PX_TO_GL-4, scene->get_height()-20, "%i", i*4);
		glColor3f(1.0, 1.0, 1.0);
		glDisable(GL_TEXTURE_2D);
		glPopMatrix();
		glFlush(); //temp
        //glColor3f(1.0, 1.0, 1.0);

		if(hzoom < 0.1) continue;

		//3 more bar lines:
		glLineWidth( hzoom < 9 ? 2 : 1 );
		glBegin( GL_LINES );
		for(j=1;j<4;j++){
			pos.beat += beats2bar;
			x += 4 * beat_width;
			glVertex3f( x, top-y[1], 0 );
			glVertex3f( x, top, 0 );
		}
		glEnd();

		if(hzoom > 0.5){
			glLineWidth( 1 );
			glBegin( GL_LINES );

			//beat lines:
			for(j=0;j<4;j++){
				for(k=1;k<beats2bar;k++){
					pos.beat = i * 4 * beats2bar + (j * beats2bar) + k;
					x = pos.beat * beat_width;
					//printf("%.2f ", x);
					glVertex3f( x, top-y[2], 0 );
					glVertex3f( x, top, 0 );
				}
			}

			if(hzoom > 1.5){

				//sub-beat lines:
				for(j=0;j<4;j++){
					for(k=0;k<beats2bar;k++){
						pos.beat = i * 4 * beats2bar + (j * beats2bar) + k;
						for(m=1;m<beats2bar;m++){
							x = pos.beat * beat_width + (beat_width * m)/ 4.0f;
							glVertex3f( x, top-y[3], 0 );
							glVertex3f( x, top, 0 );
						}
					}
				}
			}
			glEnd();
		}
	}

	dbg(4, "window=%i x %i", scene->get_width(), scene->get_height());
	glColor3f(1.0, 1.0, 0.0);
}


